'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactSelect = require('react-select');

require('./style.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactSimpleFormGenerator = function (_Component) {
  _inherits(ReactSimpleFormGenerator, _Component);

  function ReactSimpleFormGenerator(props) {
    _classCallCheck(this, ReactSimpleFormGenerator);

    var _this = _possibleConstructorReturn(this, (ReactSimpleFormGenerator.__proto__ || Object.getPrototypeOf(ReactSimpleFormGenerator)).call(this, props));

    _initialiseProps.call(_this);

    var fields = _lodash2.default.filter(_this.props.fields, function (field) {
      return !!field.autoGenerated == false && !field.references;
    });

    _this.state = {
      form: _this.getFormData(_this.props.form, fields),
      fields: fields
    };
    return _this;
  }

  _createClass(ReactSimpleFormGenerator, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState({ form: this.getFormData(nextProps.form, this.state.fields) });
    }
  }, {
    key: 'onChange',
    value: function onChange(parentKey, name, e) {
      var target = e.target;
      var value = target.type == 'checkbox' ? target.checked : target.value;
      if (parentKey) {
        this.state.form[parentKey][name] = value;
      } else {
        this.state.form[name] = value;
      }
      this.props.onChange(this.state.form);
      this.forceUpdate();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'form',
          {
            onSubmit: this.onSubmit,
            className: this.props.className + ' container'
          },
          this.props.title && _react2.default.createElement(
            'h1',
            { className: 'title' },
            this.props.title
          ),
          this.state.fields.map(this.renderInput.bind(this, null)),
          _react2.default.createElement(
            'div',
            { className: 'inputWrapper' },
            _react2.default.createElement(
              'button',
              { className: (0, _classnames2.default)("btn", this.props.submitButtonClassName) },
              this.props.submitButtonText
            )
          )
        )
      );
    }
  }]);

  return ReactSimpleFormGenerator;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.onSubmit = function (e) {
    e.preventDefault();
    var form = _lodash2.default.pickBy(_this2.state.form, function (val) {
      return val !== undefined && val !== null;
    });
    _this2.props.onSubmit(e, form);
  };

  this.onAsyncChange = function (item, selectedOption) {
    _this2.state.form[item.name] = selectedOption;
    _this2.forceUpdate();
  };

  this.getFormData = function (propForm, fields) {
    var form = _extends({}, propForm);
    var formData = {};
    var ignoreds = _lodash2.default.map(_lodash2.default.filter(fields, function (field) {
      return field.autoGenerated || field.references;
    }), 'name');
    ignoreds.forEach(function (field) {
      delete form[field];
    });
    fields.forEach(function (field) {
      if (typeof form[field.name] !== 'undefined') {
        formData[field.name] = form[field.name];
      }
    });
    return formData;
  };

  this.isDisabled = function (item) {
    for (var i = 0; i < item.showIf.length; i++) {
      var control = item.showIf[i];
      var val = _this2.state.form[control.key];
      if (!val || !control.value || control.value.indexOf(val) === -1) {
        return true;
      }
    }
    return false;
  };

  this.renderInput = function (parentKey, item) {
    var value = _this2.state.form[item.name];
    var onChange = _this2.onChange.bind(_this2, null, item.name);

    if (parentKey) {
      if (!_this2.state.form[parentKey]) {
        _this2.state.form[parentKey] = {};
      }

      value = _this2.state.form[parentKey][item.name];
      onChange = _this2.onChange.bind(_this2, parentKey, item.name);
    }

    var disabled = item.showIf && _this2.isDisabled(item);
    var wrapperClasses = (0, _classnames2.default)("inputWrapper", { "disabled": disabled });

    switch (item.type) {
      case 'textarea':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('textarea', {
              disabled: item.disabled,
              className: 'input textarea',
              name: item.name,
              value: value,
              onChange: onChange
            })
          );
        }

      case 'password':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'password',
              className: 'input',
              name: item.name,
              value: value,
              onChange: onChange
            })
          );
        }

      case 'email':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'email',
              className: 'input',
              name: item.name,
              value: value,
              onChange: onChange
            })
          );
        }

      case 'select':
        {
          if (item.loadOptions) {
            return _react2.default.createElement(
              'div',
              { className: wrapperClasses, key: item.name },
              _react2.default.createElement(
                'label',
                { className: 'label' },
                item.label || item.name
              ),
              _react2.default.createElement(_reactSelect.Async, {
                simpleValue: true,
                onSelectResetsInput: false,
                name: item.name,
                disabled: item.disabled,
                onChange: function onChange(option) {
                  return _this2.onAsyncChange(item, option);
                },
                value: _this2.state.form[item.name],
                valueKey: item.valueKey || 'id',
                labelKey: item.labelKey,
                options: item.options,
                loadOptions: item.loadOptions,
                optionRenderer: item.optionRenderer,
                autoload: item.autoload === undefined ? true : item.autoload,
                valueRenderer: item.valueRenderer
              })
            );
          } else if (item.options) {
            return _react2.default.createElement(
              'div',
              { className: wrapperClasses, key: item.name },
              _react2.default.createElement(
                'label',
                { className: 'label' },
                item.label || item.name
              ),
              _react2.default.createElement(
                'span',
                { className: 'selectWrap' },
                _react2.default.createElement(
                  'select',
                  {
                    disabled: item.disabled,
                    className: 'select',
                    value: value,
                    onChange: onChange
                  },
                  _react2.default.createElement(
                    'option',
                    { value: '' },
                    'Choose'
                  ),
                  item.options.map(function (option) {
                    return _react2.default.createElement('option', _extends({ key: option.value }, option));
                  })
                )
              )
            );
          }
          break;
        }

      case 'boolean':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'checkbox',
              name: item.name,
              id: item.name,
              checked: value,
              onChange: onChange
            }),
            _react2.default.createElement(
              'label',
              { htmlFor: item.name },
              item.name
            )
          );
        }

      case 'property':
        {
          if (item.fields) {
            return JSON.parse(item.fields).map(_this2.renderInput.bind(_this2, 'properties'));
          }

          break;
        }

      case 'number':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'number',
              className: 'input',
              min: item.min,
              max: item.max,
              name: item.name,
              value: _this2.state.form[item.name],
              onChange: onChange
            })
          );
        }

      case 'date':
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'date',
              className: 'input',
              min: item.min,
              max: item.max,
              name: item.name,
              value: _this2.state.form[item.name],
              onChange: onChange
            })
          );
        }

      default:
        {
          return _react2.default.createElement(
            'div',
            { className: wrapperClasses, key: item.name },
            _react2.default.createElement(
              'label',
              { className: 'label' },
              item.label || item.name
            ),
            _react2.default.createElement('input', {
              disabled: item.disabled,
              type: 'text',
              className: 'input',
              name: item.name,
              value: _this2.state.form[item.name],
              onChange: onChange
            })
          );
        }
    }

    return null;
  };
};

ReactSimpleFormGenerator.propTypes = {
  className: _propTypes2.default.string,
  submitButtonClassName: _propTypes2.default.string,
  title: _propTypes2.default.string,
  submitButtonText: _propTypes2.default.string,
  form: _propTypes2.default.object,
  fields: _propTypes2.default.arrayOf(_propTypes2.default.object),
  onSubmit: _propTypes2.default.func,
  onChange: _propTypes2.default.func
};

ReactSimpleFormGenerator.defaultProps = {
  className: '',
  submitButtonClassName: '',
  title: '',
  submitButtonText: 'Save',
  fields: [],
  form: {},
  onSubmit: function onSubmit() {},
  onChange: function onChange() {}
};

exports.default = ReactSimpleFormGenerator;